com.fasterxml.jackson.databind.deser.std

## Class UntypedObjectDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<Object>
    - - com.fasterxml.jackson.databind.deser.std.UntypedObjectDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, NullValueProvider, ResolvableDeserializer, Serializable

      public class UntypedObjectDeserializer
      extends StdDeserializer<Object>
      implements ResolvableDeserializer, ContextualDeserializer

  Deserializer implementation that is used if it is necessary to bind content of "unknown" type; something declared as basic `Object` (either explicitly, or due to type erasure). If so, "natural" mapping is used to convert JSON values to their natural Java object matches: JSON arrays to Java `List`s (or, if configured, Object[]), JSON objects to `Map`s, numbers to `Number`s, booleans to `Boolean`s and strings to `String` (and nulls to nulls).
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `UntypedObjectDeserializer.Vanilla` Streamlined version of `UntypedObjectDeserializer` that has fewer checks and is only used when no custom deserializer overrides are applied.

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JsonDeserializer<Object>` | `_listDeserializer`
    `protected JavaType` | `_listType` If `List` has been mapped to non-default implementation, we'll store type here
    `protected JsonDeserializer<Object>` | `_mapDeserializer`
    `protected JavaType` | `_mapType` If `Map` has been mapped to non-default implementation, we'll store type here
    `protected boolean` | `_nonMerging`
    `protected JsonDeserializer<Object>` | `_numberDeserializer`
    `protected JsonDeserializer<Object>` | `_stringDeserializer`
    `protected static Object[]` | `NO_OBJECTS`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `UntypedObjectDeserializer()` Deprecated. Since 2.6 use variant takes type arguments
    `` | `UntypedObjectDeserializer(JavaType listType, JavaType mapType)`
    `protected` | `UntypedObjectDeserializer(UntypedObjectDeserializer base, boolean nonMerging)`
    `` | `UntypedObjectDeserializer(UntypedObjectDeserializer base, JsonDeserializer<?> mapDeser, JsonDeserializer<?> listDeser, JsonDeserializer<?> stringDeser, JsonDeserializer<?> numberDeser)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JsonDeserializer<Object>` | `_clearIfStdImpl(JsonDeserializer<Object> deser)`
    `protected JsonDeserializer<Object>` | `_findCustomDeser(DeserializationContext ctxt, JavaType type)`
    `JsonDeserializer<?>` | `createContextual(DeserializationContext ctxt, BeanProperty property)` We only use contextualization for optimizing the case where no customization occurred; if so, can slip in a more streamlined version.
    `Object` | `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `Object` | `deserialize(JsonParser p, DeserializationContext ctxt, Object intoValue)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
    `Object` | `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `boolean` | `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).
    `protected Object` | `mapArray(JsonParser p, DeserializationContext ctxt)` Method called to map a JSON Array into a Java value.
    `protected Object` | `mapArray(JsonParser p, DeserializationContext ctxt, Collection<Object> result)`
    `protected Object[]` | `mapArrayToArray(JsonParser p, DeserializationContext ctxt)` Method called to map a JSON Array into a Java Object array (Object[]).
    `protected Object` | `mapObject(JsonParser p, DeserializationContext ctxt)` Method called to map a JSON Object into a Java value.
    `protected Object` | `mapObject(JsonParser p, DeserializationContext ctxt, Map<Object,Object> m)`
    `void` | `resolve(DeserializationContext ctxt)` We need to implement this method to properly find things to delegate to: it cannot be done earlier since delegated deserializers almost certainly require access to this instance (at least "List" and "Map" ones)
    `Boolean` | `supportsUpdate(DeserializationConfig config)` Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_byteOverflow, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeWrappedValue, _failDoubleToIntCoercion, _findNullProvider, _hasTextualNull, _intOverflow, _isEmptyOrTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _neitherNull, _nonNullNumber, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueType, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserializeWithType, findBackReference, getDelegatee, getEmptyAccessPattern, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getNullValue, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NO_OBJECTS

          protected static final Object[] NO_OBJECTS

    - #### _mapDeserializer

          protected JsonDeserializer<Object> _mapDeserializer

    - #### _listDeserializer

          protected JsonDeserializer<Object> _listDeserializer

    - #### _stringDeserializer

          protected JsonDeserializer<Object> _stringDeserializer

    - #### _numberDeserializer

          protected JsonDeserializer<Object> _numberDeserializer

    - #### _listType

          protected JavaType _listType

      If `List` has been mapped to non-default implementation, we'll store type here
      Since:
        2.6

    - #### _mapType

          protected JavaType _mapType

      If `Map` has been mapped to non-default implementation, we'll store type here
      Since:
        2.6

    - #### _nonMerging

          protected final boolean _nonMerging

      Since:
        2.9

  - ### Constructor Detail

    - #### UntypedObjectDeserializer

          @Deprecated
          public UntypedObjectDeserializer()

      Deprecated. Since 2.6 use variant takes type arguments

    - #### UntypedObjectDeserializer

          public UntypedObjectDeserializer(JavaType listType,
                                           JavaType mapType)

    - #### UntypedObjectDeserializer

          public UntypedObjectDeserializer(UntypedObjectDeserializer base,
                                           JsonDeserializer<?> mapDeser,
                                           JsonDeserializer<?> listDeser,
                                           JsonDeserializer<?> stringDeser,
                                           JsonDeserializer<?> numberDeser)

    - #### UntypedObjectDeserializer

          protected UntypedObjectDeserializer(UntypedObjectDeserializer base,
                                              boolean nonMerging)

      Since:
        2.9

  - ### Method Detail

    - #### resolve

          public void resolve(DeserializationContext ctxt)
                       throws JsonMappingException

      We need to implement this method to properly find things to delegate to: it cannot be done earlier since delegated deserializers almost certainly require access to this instance (at least "List" and "Map" ones)
      Specified by:
        `resolve` in interface `ResolvableDeserializer`
      Parameters:
        `ctxt` - Context to use for accessing configuration, resolving secondary deserializers
      Throws:
        `JsonMappingException`

    - #### _findCustomDeser

          protected JsonDeserializer<Object> _findCustomDeser(DeserializationContext ctxt,
                                                              JavaType type)
                                                       throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _clearIfStdImpl

          protected JsonDeserializer<Object> _clearIfStdImpl(JsonDeserializer<Object> deser)

    - #### createContextual

          public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                      BeanProperty property)
                                               throws JsonMappingException

      We only use contextualization for optimizing the case where no customization occurred; if so, can slip in a more streamlined version.
      Specified by:
        `createContextual` in interface `ContextualDeserializer`
      Parameters:
        `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
        `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
      Returns:
        Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### isCachable

          public boolean isCachable()

      Description copied from class: `JsonDeserializer`
      Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

      Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

      Default implementation returns false, to indicate that no caching is done.

      Overrides:
        `isCachable` in class `JsonDeserializer<Object>`

    - #### supportsUpdate

          public Boolean supportsUpdate(DeserializationConfig config)

      Description copied from class: `JsonDeserializer`
      Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not. Return value should either be `Boolean.FALSE` if update is not supported at all (immutable values); `Boolean.TRUE` if update should usually work (regular POJOs, for example), or `null` if this is either not known, or may sometimes work.

      Information gathered is typically used to either prevent merging update for property (either by skipping, if based on global defaults; or by exception during deserialization construction if explicit attempt made) if `Boolean.FALSE` returned, or inclusion if `Boolean.TRUE` is specified. If "unknown" case (`null` returned) behavior is to exclude property if global defaults used; or to allow if explicit per-type or property merging is defined.

      Default implementation returns `null` to allow explicit per-type or per-property attempts.

      Overrides:
        `supportsUpdate` in class `JsonDeserializer<Object>`

    - #### deserialize

          public Object deserialize(JsonParser p,
                                    DeserializationContext ctxt)
                             throws IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (p.currentToken() == JsonToken.START_OBJECT) {
                   p.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<Object>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `IOException`

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser p,
                                            DeserializationContext ctxt,
                                            TypeDeserializer typeDeserializer)
                                     throws IOException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<Object>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`

    - #### deserialize

          public Object deserialize(JsonParser p,
                                    DeserializationContext ctxt,
                                    Object intoValue)
                             throws IOException

      Description copied from class: `JsonDeserializer`
      Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

      Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

      Overrides:
        `deserialize` in class `JsonDeserializer<Object>`
      Throws:
        `IOException`

    - #### mapArray

          protected Object mapArray(JsonParser p,
                                    DeserializationContext ctxt)
                             throws IOException

      Method called to map a JSON Array into a Java value.
      Throws:
        `IOException`

    - #### mapArray

          protected Object mapArray(JsonParser p,
                                    DeserializationContext ctxt,
                                    Collection<Object> result)
                             throws IOException

      Throws:
        `IOException`

    - #### mapObject

          protected Object mapObject(JsonParser p,
                                     DeserializationContext ctxt)
                              throws IOException

      Method called to map a JSON Object into a Java value.
      Throws:
        `IOException`

    - #### mapArrayToArray

          protected Object[] mapArrayToArray(JsonParser p,
                                             DeserializationContext ctxt)
                                      throws IOException

      Method called to map a JSON Array into a Java Object array (Object[]).
      Throws:
        `IOException`

    - #### mapObject

          protected Object mapObject(JsonParser p,
                                     DeserializationContext ctxt,
                                     Map<Object,Object> m)
                              throws IOException

      Throws:
        `IOException`

Copyright © 2008–2020 FasterXML. All rights reserved.